Subject: Re: bug#79021: 31.0.50; Unnecessary GC in after-load-functions

From: Stefan Monnier <[email-masked]>
Date: Tue, 15 Jul 2025 09:59:38 -0400

>> In loadup.el there is this:
>> 
>>   (add-hook 'after-load-functions (lambda (_) (garbage-collect)))
>> 
>> What's this for?  It seems unnecessary.
>> 
>> It would be nice to remove this, because without it the time to execute
>> loadup.el goes down from 13 seconds to 6.
>
> I presume this is because we don't want to dump any garbage.
> Stefan?

AFAIK it was added to keep the dumped Emacs' heap "dense": if we run the
GC only "in the normal way", the heap objects created during `loadup.el`
end up interspersed with more free spaces.

It's possible/likely that the portable dumper has made that unnecessary.

        Stefan